Index: src/zap_isdn.c
===================================================================
--- src/zap_isdn.c	(revision 495)
+++ src/zap_isdn.c	(working copy)
@@ -44,6 +44,10 @@
 #define LINE "--------------------------------------------------------------------------------"
 //#define IODEBUG
 
+/* helper macros */
+#define ZAP_SPAN_IS_BRI(x)	((x)->trunk_type == ZAP_TRUNK_BRI || (x)->trunk_type == ZAP_TRUNK_BRI_PTMP)
+#define ZAP_SPAN_IS_ALAW(x)	((x)->trunk_type == ZAP_TRUNK_E1 || (x)->trunk_type == ZAP_TRUNK_BRI || (x)->trunk_type == ZAP_TRUNK_BRI_PTMP)	/* TODO: baaaad hack */
+
 static L2ULONG zap_time_now(void)
 {
 	return (L2ULONG)zap_current_time_in_ms();
@@ -67,84 +71,113 @@
 	Q931ie_CalledNum CalledNum;
 	Q931ie_CalledNum *ptrCalledNum;
 	Q931ie_Display Display, *ptrDisplay;
+	Q931ie_HLComp HLComp;			/* High-Layer Compatibility IE */
 	zap_status_t status = ZAP_FAIL;
 	zap_isdn_data_t *isdn_data = span->signal_data;
 	int sanity = 60000;
 
-	Q931InitIEBearerCap(&BearerCap);
-	Q931InitIEChanID(&ChanID);
-	Q931InitIECallingNum(&CallingNum);
-	Q931InitIECalledNum(&CalledNum);
-	Q931InitIEDisplay(&Display);
-
 	Q931InitMesGeneric(gen);
 	gen->MesType = Q931mes_SETUP;
 
-	BearerCap.CodStand = 0; /* ITU-T = 0, ISO/IEC = 1, National = 2, Network = 3 */
-	BearerCap.ITC = 0; /* Speech */
-	BearerCap.TransMode = 0; /* Circuit = 0, Packet = 1 */
-	BearerCap.ITR = 16; /* 64k */
+	/*
+	 * Bearer Capability IE
+	 */
+	Q931InitIEBearerCap(&BearerCap);
+	BearerCap.CodStand = 0;			/* ITU-T = 0, ISO/IEC = 1, National = 2, Network = 3 */
+	BearerCap.ITC = 0;			/* Speech */
+	BearerCap.TransMode = 0;		/* Circuit = 0, Packet = 1 */
+	BearerCap.ITR = 16;			/* 64k */
 	BearerCap.Layer1Ident = 1;
-	BearerCap.UIL1Prot = 2; /* U-law (a-law = 3)*/
-
+	BearerCap.UIL1Prot = ZAP_SPAN_IS_ALAW(span) ? 3 : 2;	/* U-law = 2, A-law = 3 */
 	gen->BearerCap = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &BearerCap);
 
-	ChanID.IntType = 1; /* PRI = 1, BRI = 0 */
-	ChanID.PrefExcl = (isdn_data->opts & ZAP_ISDN_OPT_SUGGEST_CHANNEL) ? 0 : 1; /* 0 = preferred, 1 exclusive */
-	ChanID.InfoChanSel = 1;
-	ChanID.ChanMapType = 3; /* B-Chan */
-	ChanID.ChanSlot = chan_id;
+	/*
+	 * Channel ID IE
+	 */
+	Q931InitIEChanID(&ChanID);
+	ChanID.IntType = ZAP_SPAN_IS_BRI(span) ? 1 : 0;		/* PRI = 1, BRI = 0 */
+	ChanID.PrefExcl = (isdn_data->opts & ZAP_ISDN_OPT_SUGGEST_CHANNEL) ? 0 : 1;	/* 0 = preferred, 1 exclusive */
+	if(ChanID.IntType) {
+		ChanID.InfoChanSel = 1;				/* None = 0, See Slot = 1, Any = 3 */
+		ChanID.ChanMapType = 3;				/* B-Chan */
+		ChanID.ChanSlot = (unsigned char)chan_id;
+	} else {
+		ChanID.InfoChanSel = (unsigned char)chan_id & 0x03;	/* None = 0, B1 = 1, B2 = 2, Any = 3 */
+	}
 	gen->ChanID = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &ChanID);
-			
+
+	/*
+	 * Display IE
+	 */
+	Q931InitIEDisplay(&Display);
 	Display.Size = Display.Size + (unsigned char)strlen(caller_data->cid_name);
 	gen->Display = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &Display);			
 	ptrDisplay = Q931GetIEPtr(gen->Display, gen->buf);
 	zap_copy_string((char *)ptrDisplay->Display, caller_data->cid_name, strlen(caller_data->cid_name)+1);
 
-	/* TypNum: Type of number		*/
-	/* Bits 7 6 5					*/
-	/* 000	Unknown					*/
+	/*
+	 * High-Layer Compatibility IE   (Note: Required for AVM FritzBox)
+	 */
+	Q931InitIEHLComp(&HLComp);
+	HLComp.CodStand  = 0;	/* ITU */
+	HLComp.Interpret = 4;	/* only possible value */
+	HLComp.PresMeth  = 1;   /* High-layer protocol profile */
+	HLComp.HLCharID  = 0;	/* Telephony = 0, Fax G2+3 = 4, Fax G4 = 65 (Class I)/ 68 (Class II or III) */
+	gen->HLComp = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &HLComp);
+
+	/*
+	 * Calling Number IE
+	 */
+	Q931InitIECallingNum(&CallingNum);
+	/* TypNum: Type of number	*/
+	/* Bits 7 6 5			*/
+	/* 000	Unknown			*/
 	/* 001	International number	*/
-	/* 010	National number			*/
+	/* 010	National number		*/
 	/* 011	Network Specific number */
-	/* 100	Subscriber mumber		*/
-	/* 110	Abbreviated number		*/
+	/* 100	Subscriber mumber	*/
+	/* 110	Abbreviated number	*/
 	/* 111	Reserved for extension	*/
-	/* All other values are reserved */
+	/* All other values are reserved*/
 	CallingNum.TypNum = 2;
 
-	/* NumPlanID									*/
-	/* Bits 4 3 2 1									*/
-	/* 0000	Unknown									*/
+	/* NumPlanID					*/
+	/* Bits 4 3 2 1					*/
+	/* 0000	Unknown					*/
 	/* 0001	ISDN/telephony numbering plan (E.164)	*/
-	/* 0011	Data numbering plan (X.121)				*/
-	/* 0100	Telex numbering plan (F.69)				*/
-	/* 1000	National standard numbering plan		*/
-	/* 1001	Private numbering plan					*/
-	/* 1111	Reserved for extension					*/
-	/* All other valures are reserved				*/
+	/* 0011	Data numbering plan (X.121)		*/
+	/* 0100	Telex numbering plan (F.69)		*/
+	/* 1000	National standard numbering plan	*/
+	/* 1001	Private numbering plan			*/
+	/* 1111	Reserved for extension			*/
+	/* All other valures are reserved		*/
 	CallingNum.NumPlanID = 1;
 
-	/* Presentation indicator		*/
+	/* Presentation indicator				*/
 	/* Bits 7 6						*/
-	/* 00	Presenation Allowed		*/
-	/* 01	Presentation Restricted	*/
+	/* 00	Presenation Allowed				*/
+	/* 01	Presentation Restricted				*/
 	/* 10	Number not available due to internetworking	*/
-	/* 11	Reserved				*/
+	/* 11	Reserved					*/
 	CallingNum.PresInd = 0;
 
-	/* Screening Indicator						*/
-	/* Bits 2 1									*/
-	/* 00	User-provided, not screened			*/
+	/* Screening Indicator				*/
+	/* Bits 2 1					*/
+	/* 00	User-provided, not screened		*/
 	/* 01	User-provided, verified and passed	*/
 	/* 10	User-provided, verified and failed	*/
-	/* 11	Network provided					*/
+	/* 11	Network provided			*/
 	CallingNum.ScreenInd = 0;
 	CallingNum.Size = CallingNum.Size + (unsigned char)strlen(caller_data->cid_num.digits);
 	gen->CallingNum = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &CallingNum);			
 	ptrCallingNum = Q931GetIEPtr(gen->CallingNum, gen->buf);
 	zap_copy_string((char *)ptrCallingNum->Digit, caller_data->cid_num.digits, strlen(caller_data->cid_num.digits)+1);
 
+
+	/*
+	 * Called number IE
+	 */
+	Q931InitIECalledNum(&CalledNum);
 	CalledNum.TypNum = 2;
 	CalledNum.NumPlanID = 1;
 	CalledNum.Size = CalledNum.Size + (unsigned char)strlen(caller_data->ani.digits);
@@ -207,11 +240,11 @@
 				memset(&new_chan->caller_data, 0, sizeof(new_chan->caller_data));
 				zap_set_flag(new_chan, ZAP_CHANNEL_OUTBOUND);
 				zap_set_state_locked(new_chan, ZAP_CHANNEL_STATE_DIALING);
+
 				switch(gen->MesType) {
 				case Q931mes_ALERTING:
 					new_chan->init_state = ZAP_CHANNEL_STATE_PROGRESS_MEDIA;
 					break;
-					break;
 				case Q931mes_CONNECT:
 					new_chan->init_state = ZAP_CHANNEL_STATE_UP;
 					break;
@@ -229,7 +262,9 @@
 			return ZAP_SUCCESS;
 		} else {
 			Q931ie_Cause cause;
+
 			gen->MesType = Q931mes_DISCONNECT;
+
 			cause.IEId = Q931ie_CAUSE;
 			cause.Size = sizeof(Q931ie_Cause);
 			cause.CodStand  = 0;
@@ -239,6 +274,7 @@
 			cause.Value = (unsigned char) ZAP_CAUSE_WRONG_CALL_STATE;
 			*cause.Diag = '\0';
 			gen->Cause = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
+
 			Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
 
 			if (gen->CRV) {
@@ -258,6 +294,12 @@
 
 }
 
+static L3INT zap_isdn_q931_log(void *pvt, Q931LogLevel_t level, char *msg, L3INT size)
+{
+	zap_log(__FILE__, "Q.931", __LINE__, ZAP_LOG_LEVEL_DEBUG, "%s", msg);
+	return 0;
+}
+
 static L3INT zap_isdn_931_err(void *pvt, L3INT id, L3INT p1, L3INT p2)
 {
 	zap_log(ZAP_LOG_ERROR, "ERROR: [%s] [%d] [%d]\n", q931_error_to_name(id), p1, p2);
@@ -275,7 +317,11 @@
 
 	if (Q931IsIEPresent(gen->ChanID)) {
 		Q931ie_ChanID *chanid = Q931GetIEPtr(gen->ChanID, gen->buf);
-		chan_id = chanid->ChanSlot;
+
+		if(chanid->IntType)
+			chan_id = chanid->ChanSlot;
+		else
+			chan_id = chanid->InfoChanSel;
 	}
 
 	assert(span != NULL);
@@ -295,9 +341,7 @@
 		case Q931mes_ALERTING:
 		case Q931mes_PROGRESS:
 		case Q931mes_CONNECT:
-			{
-				caller_data->call_state = ZAP_CALLER_STATE_SUCCESS;
-			}
+			caller_data->call_state = ZAP_CALLER_STATE_SUCCESS;
 			break;
 		default:
 			caller_data->call_state = ZAP_CALLER_STATE_FAIL;
@@ -313,9 +357,6 @@
 		zchan = isdn_data->channels_remote_crv[gen->CRV];
 	}
 
-
-
-
 	if (gen->ProtDisc == 3) {
 		switch(gen->MesType) {
 		case Q931mes_SERVICE:
@@ -431,13 +472,20 @@
 				zap_status_t status;
 				int fail = 1;
 				uint32_t cplen = mlen;
-				
+
+				zap_log(ZAP_LOG_DEBUG, "Q.931 SETUP Message recived, requested Channel ID: %d (available on span: %d)\n", chan_id, span->chan_count);
+
 				zchan = NULL;
 				if (chan_id < ZAP_MAX_CHANNELS_SPAN && chan_id <= span->chan_count) {
 					zchan = &span->channels[chan_id];
 				}
 
 				if (zchan && (status = zap_channel_open_chan(zchan) == ZAP_SUCCESS)) {
+					zap_log(ZAP_LOG_DEBUG, "Successfully opened requested channel %d [inuse: %s, state: %d]\n",
+										chan_id,
+										zap_test_flag(zchan, ZAP_CHANNEL_INUSE) ? "yes" : "no",
+										zchan->state);
+
 					if (zap_test_flag(zchan, ZAP_CHANNEL_INUSE) || zchan->state != ZAP_CHANNEL_STATE_DOWN) {
 						if (zchan->state == ZAP_CHANNEL_STATE_DOWN || zchan->state >= ZAP_CHANNEL_STATE_TERMINATING) {
 							int x = 0;
@@ -462,6 +510,8 @@
 					}
 
 					if (zchan && zchan->state == ZAP_CHANNEL_STATE_DOWN) {
+						zap_log(ZAP_LOG_DEBUG, "Request channel is down, preparing for activation\n");
+
 						isdn_data->channels_remote_crv[gen->CRV] = zchan;
 						memset(&zchan->caller_data, 0, sizeof(zchan->caller_data));
 
@@ -485,6 +535,7 @@
 				if (fail) {
 					Q931ie_Cause cause;
 					gen->MesType = Q931mes_DISCONNECT;
+
 					cause.IEId = Q931ie_CAUSE;
 					cause.Size = sizeof(Q931ie_Cause);
 					cause.CodStand  = 0;
@@ -494,6 +545,7 @@
 					cause.Value = (unsigned char) ZAP_CAUSE_WRONG_CALL_STATE;
 					*cause.Diag = '\0';
 					gen->Cause = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
+
 					Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
 
 					if (gen->CRV) {
@@ -518,16 +570,23 @@
 	return 0;
 }
 
-static int zap_isdn_921_23(void *pvt, L2UCHAR *msg, L2INT mlen)
+static int zap_isdn_921_23(void *pvt, Q921DLMsg_t ind, L2UCHAR *msg, L2INT mlen)
 {
-	int ret;
+	int ret, offset = (ind == Q921_DL_DATA) ? 4 : 3;
 	char bb[4096] = "";
-	print_hex_bytes(msg+4, mlen-2, bb, sizeof(bb));
-	zap_log(ZAP_LOG_DEBUG, "READ %d\n%s\n%s\n\n", (int)mlen-2, LINE, bb);
 
-	ret = Q931Rx23(pvt, msg, mlen);
-	if (ret != 0)
-		zap_log(ZAP_LOG_DEBUG, "931 parse error [%d] [%s]\n", ret, q931_error_to_name(ret));
+	switch(ind) {
+	case Q921_DL_DATA:
+	case Q921_DL_UNIT_DATA:
+		print_hex_bytes(msg + offset, mlen - offset, bb, sizeof(bb));
+		zap_log(ZAP_LOG_DEBUG, "READ %d\n%s\n%s\n\n", (int)mlen - offset, LINE, bb);
+	default:
+		ret = Q931Rx23(pvt, ind, msg, mlen);
+		if (ret != 0)
+			zap_log(ZAP_LOG_DEBUG, "931 parse error [%d] [%s]\n", ret, q931_error_to_name(ret));
+		break;
+	}
+
 	return ((ret >= 0) ? 1 : 0);
 }
 
@@ -542,7 +601,6 @@
 	print_hex_bytes(msg, len, bb, sizeof(bb));
 	print_bits(msg, (int)len, bb, sizeof(bb), ZAP_ENDIAN_LITTLE, 0);
 	zap_log(ZAP_LOG_DEBUG, "WRITE %d\n%s\n%s\n\n", (int)len, LINE, bb);
-
 #endif
 
 	assert(span != NULL);
@@ -641,36 +699,51 @@
 			Q931ie_CalledNum CalledNum;
 			Q931ie_CalledNum *ptrCalledNum;
 			Q931ie_Display Display, *ptrDisplay;
-			
-			Q931InitIEBearerCap(&BearerCap);
-			Q931InitIEChanID(&ChanID);
-			Q931InitIECallingNum(&CallingNum);
-			Q931InitIECalledNum(&CalledNum);
-			Q931InitIEDisplay(&Display);
+			Q931ie_HLComp HLComp;			/* High-Layer Compatibility IE */
 
 			Q931InitMesGeneric(gen);
 			gen->MesType = Q931mes_SETUP;
 
-			BearerCap.CodStand = 0; /* ITU-T = 0, ISO/IEC = 1, National = 2, Network = 3 */
-			BearerCap.ITC = 0; /* Speech */
-			BearerCap.TransMode = 0; /* Circuit = 0, Packet = 1 */
-			BearerCap.ITR = 16; /* 64k */
+			/*
+			 * Bearer Capability IE
+			 */
+			Q931InitIEBearerCap(&BearerCap);
+			BearerCap.CodStand = 0;			/* ITU-T = 0, ISO/IEC = 1, National = 2, Network = 3 */
+			BearerCap.ITC = 0;			/* Speech */
+			BearerCap.TransMode = 0;		/* Circuit = 0, Packet = 1 */
+			BearerCap.ITR = 16;			/* 64k = 16, Packet mode = 0 */
 			BearerCap.Layer1Ident = 1;
-			BearerCap.UIL1Prot = 2; /* U-law (a-law = 3)*/
+			BearerCap.UIL1Prot = ZAP_SPAN_IS_ALAW(zchan->span) ? 3 : 2;	/* U-law = 2, A-law = 3 */
 			gen->BearerCap = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &BearerCap);
 
-			//is cast right here?
-			ChanID.IntType = 1; /* PRI = 1, BRI = 0 */
-			ChanID.InfoChanSel = 1;
-			ChanID.ChanMapType = 3; /* B-Chan */
-			ChanID.ChanSlot = (unsigned char)zchan->chan_id;
+			/*
+			 * ChannelID IE
+			 */
+			Q931InitIEChanID(&ChanID);
+			ChanID.IntType = ZAP_SPAN_IS_BRI(zchan->span) ? 0 : 1;	/* PRI = 1, BRI = 0 */
+			if(ChanID.IntType) {
+				ChanID.InfoChanSel = 1;		/* None = 0, See Slot = 1, Any = 3 */
+				ChanID.ChanMapType = 3;		/* B-Chan */
+				ChanID.ChanSlot = (unsigned char)zchan->chan_id;
+			} else {
+				ChanID.InfoChanSel = (unsigned char)zchan->chan_id & 0x03;	/* None = 0, B1 = 1, B2 = 2, Any = 3 */
+			}
 			gen->ChanID = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &ChanID);
-			
+
+			/*
+			 * Display IE
+			 */			
+			Q931InitIEDisplay(&Display);
 			Display.Size = Display.Size + (unsigned char)strlen(zchan->caller_data.cid_name);
 			gen->Display = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &Display);
 			ptrDisplay = Q931GetIEPtr(gen->Display, gen->buf);
 			zap_copy_string((char *)ptrDisplay->Display, zchan->caller_data.cid_name, strlen(zchan->caller_data.cid_name)+1);
 
+			/*
+			 * CallingNum IE
+			 */ 
+			Q931InitIECallingNum(&CallingNum);
+
 			/* TypNum: Type of number*/
 			/* Bits 7 6 5*/
 			/* 000Unknown*/
@@ -715,6 +788,10 @@
 			ptrCallingNum = Q931GetIEPtr(gen->CallingNum, gen->buf);
 			zap_copy_string((char *)ptrCallingNum->Digit, zchan->caller_data.cid_num.digits, strlen(zchan->caller_data.cid_num.digits)+1);
 
+			/*
+			 * CalledNum IE
+			 */
+			Q931InitIECalledNum(&CalledNum);
 			CalledNum.TypNum = 2;
 			CalledNum.NumPlanID = 1;
 			CalledNum.Size = CalledNum.Size + (unsigned char)strlen(zchan->caller_data.ani.digits);
@@ -722,6 +799,16 @@
 			ptrCalledNum = Q931GetIEPtr(gen->CalledNum, gen->buf);
 			zap_copy_string((char *)ptrCalledNum->Digit, zchan->caller_data.ani.digits, strlen(zchan->caller_data.ani.digits)+1);
 
+			/*
+			 * High-Layer Compatibility IE   (Note: Required for AVM FritzBox)
+			 */
+			Q931InitIEHLComp(&HLComp);
+			HLComp.CodStand  = 0;	/* ITU */
+			HLComp.Interpret = 4;	/* only possible value */
+			HLComp.PresMeth  = 1;   /* High-layer protocol profile */
+			HLComp.HLCharID  = 0;	/* Telephony = 0, Fax G2+3 = 4, Fax G4 = 65 (Class I)/ 68 (Class II or III) */   /* TODO: make accessible from user layer */
+			gen->HLComp = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &HLComp);
+
 			Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
 			isdn_data->channels_local_crv[gen->CRV] = zchan;
 		}
@@ -735,6 +822,7 @@
 		{
 			Q931ie_Cause cause;
 			gen->MesType = Q931mes_DISCONNECT;
+
 			cause.IEId = Q931ie_CAUSE;
 			cause.Size = sizeof(Q931ie_Cause);
 			cause.CodStand  = 0;
@@ -744,6 +832,7 @@
 			cause.Value = (unsigned char) zchan->caller_data.hangup_cause;
 			*cause.Diag = '\0';
 			gen->Cause = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
+
 			Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
 		}
 		break;
@@ -752,6 +841,7 @@
 			sig.event_id = ZAP_SIGEVENT_STOP;
 			status = isdn_data->sig_cb(&sig);
 			gen->MesType = Q931mes_RELEASE;
+
 			Q931Rx43(&isdn_data->q931, (void *)gen, gen->Size);
 		}
 	default:
@@ -859,7 +949,7 @@
 	int errs = 0;
 
 #ifdef WIN32
-    timeBeginPeriod(1);
+	timeBeginPeriod(1);
 #endif
 
 	zap_log(ZAP_LOG_DEBUG, "ISDN thread starting.\n");
@@ -925,7 +1015,7 @@
 	zap_clear_flag(isdn_data, ZAP_ISDN_RUNNING);
 
 #ifdef WIN32
-    timeEndPeriod(1);
+	timeEndPeriod(1);
 #endif
 
 	zap_log(ZAP_LOG_DEBUG, "ISDN thread ended.\n");
@@ -948,17 +1038,61 @@
 	return zap_thread_create_detached(zap_isdn_run, span);
 }
 
-static int q931_rx_32(void *pvt,L3UCHAR *msg, L3INT mlen)
+static int q931_rx_32(void *pvt, Q921DLMsg_t ind, L3UCHAR *msg, L3INT mlen)
 {
-	int ret;
+	int offset = 4;
 	char bb[4096] = "";
-	ret = Q921Rx32(pvt, msg, mlen);
-	print_hex_bytes(msg, mlen, bb, sizeof(bb));
-	zap_log(ZAP_LOG_DEBUG, "WRITE %d\n%s\n%s\n\n", (int)mlen, LINE, bb);
-	return ret;
+
+	switch(ind) {
+	case Q921_DL_UNIT_DATA:
+		offset = 3;
+
+	case Q921_DL_DATA:
+		print_hex_bytes(msg + offset, mlen - offset, bb, sizeof(bb));
+		zap_log(ZAP_LOG_DEBUG, "WRITE %d\n%s\n%s\n\n", (int)mlen - offset, LINE, bb);
+		break;
+
+	default:
+		break;
+	}
+
+	return Q921Rx32(pvt, ind, msg, mlen);
 }
 
+static int zap_isdn_q921_log(void *pvt, Q921LogLevel_t level, char *msg, L2INT size)
+{
+	int loglevel = ZAP_LOG_LEVEL_DEBUG;
 
+	switch(level) {
+	case Q921_LOG_DEBUG:
+		loglevel = ZAP_LOG_LEVEL_DEBUG;
+		break;
+
+	case Q921_LOG_INFO:
+		loglevel = ZAP_LOG_LEVEL_INFO;
+		break;
+
+	case Q921_LOG_NOTICE:
+		loglevel = ZAP_LOG_LEVEL_NOTICE;
+		break;
+
+	case Q921_LOG_WARNING:
+		loglevel = ZAP_LOG_LEVEL_WARNING;
+		break;
+
+	case Q921_LOG_ERROR:
+		loglevel = ZAP_LOG_LEVEL_ERROR;
+		break;
+
+	default:
+		return 0;
+	}
+
+	zap_log(__FILE__, "Q.921", __LINE__, loglevel, "%s", msg);
+
+	return 0;
+}
+
 static zap_state_map_t isdn_state_map = {
 	{
 		{
@@ -1113,22 +1247,29 @@
 				   0,
 				   0,
 				   mode,
+				   span->trunk_type == ZAP_TRUNK_BRI_PTMP ? Q921_PTMP : Q921_PTP,
 				   0,
 				   zap_isdn_921_21,
-				   (Q921TxCB_t)zap_isdn_921_23,
+				   (Q921Tx23CB_t)zap_isdn_921_23,
 				   span,
 				   &isdn_data->q931);
+
+	Q921SetLogCB(&isdn_data->q921, &zap_isdn_q921_log, isdn_data);
+	Q921SetLogLevel(&isdn_data->q921, Q921_LOG_DEBUG);
 	
 	Q931Api_InitTrunk(&isdn_data->q931,
 					  dialect,
 					  mode,
 					  span->trunk_type,
 					  zap_isdn_931_34,
-					  (Q931TxCB_t)q931_rx_32,
+					  (Q931Tx32CB_t)q931_rx_32,
 					  zap_isdn_931_err,
 					  &isdn_data->q921,
 					  span);
 
+	Q931SetLogCB(&isdn_data->q931, &zap_isdn_q931_log, isdn_data);
+	Q931SetLogLevel(&isdn_data->q931, Q931_LOG_DEBUG);
+
 	isdn_data->q931.autoRestartAck = 1;
 	isdn_data->q931.autoConnectAck = 1;
 	isdn_data->q931.autoServiceAck = 1;
Index: src/include/zap_types.h
===================================================================
--- src/include/zap_types.h	(revision 495)
+++ src/include/zap_types.h	(working copy)
@@ -117,11 +117,12 @@
 	ZAP_TRUNK_T1,
 	ZAP_TRUNK_J1,
 	ZAP_TRUNK_BRI,
+	ZAP_TRUNK_BRI_PTMP,
 	ZAP_TRUNK_FXO,
 	ZAP_TRUNK_FXS,
 	ZAP_TRUNK_NONE
 } zap_trunk_type_t;
-#define TRUNK_STRINGS "E1", "T1", "J1", "BRI", "FXO", "FXS", "NONE"
+#define TRUNK_STRINGS "E1", "T1", "J1", "BRI", "BRI_PTMP", "FXO", "FXS", "NONE"
 ZAP_STR2ENUM_P(zap_str2zap_trunk_type, zap_trunk_type2str, zap_trunk_type_t)
 
 typedef enum {
Index: src/isdn/Q931.c
===================================================================
--- src/isdn/Q931.c	(revision 495)
+++ src/isdn/Q931.c	(working copy)
@@ -36,6 +36,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 *****************************************************************************/
 
+#include "Q921.h"
 #include "Q931.h"
 #include "national.h"
 #include "DMS.h"
@@ -93,10 +94,9 @@
 
 *****************************************************************************/
 
-Q931ErrorCB_t Q931ErrorProc;
-                                    /* callback for error messages.         */
+Q931ErrorCB_t Q931ErrorProc;			/* callback for error messages.         */
 
-L3ULONG (*Q931GetTimeProc) (void) = NULL; /* callback for func reading time in ms */
+L3ULONG (*Q931GetTimeProc) (void) = NULL;	/* callback for func reading time in ms */
 
 /*****************************************************************************
 
@@ -331,36 +331,44 @@
                 see q931errors.h for details.
 
 *****************************************************************************/
-L3INT Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3UCHAR * buf, L3INT Size)
+L3INT Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3INT ind, L3UCHAR * buf, L3INT Size)
 {
-    L3UCHAR *Mes = &buf[Q931L2HeaderSpace];
-    L3INT RetCode = Q931E_NO_ERROR;
-    Q931mes_Generic *m = (Q931mes_Generic *) pTrunk->L3Buf;
-    L3INT ISize;
+	L3UCHAR *Mes = buf;
+	L3INT RetCode = Q931E_NO_ERROR;
+	Q931mes_Generic *m = (Q931mes_Generic *) pTrunk->L3Buf;
+	L3INT ISize;
+	L3INT IOff = Q931L2HeaderSpace;
 
-    L3INT IOff = 0;
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Received message from Q.921 (%d) size: %d\n", ind, Size);
 
-    /* Protocol Discriminator */
-    m->ProtDisc = Mes[IOff++];
+	switch(ind) {
+	case Q921_DL_UNIT_DATA:		/* DL-UNITDATA indication (UI frame, 3 byte header) */
+		IOff = 3;
 
-    /* CRV */
-    m->CRVFlag = Mes[IOff + 1] & 0x80;
-    m->CRV = Q931Uie_CRV(pTrunk, Mes, m->buf, &IOff, &ISize);
+	case Q921_DL_DATA:		/* DL-DATA indication (I frame, 4 byte header) */
+		/* Protocol Discriminator */
+		m->ProtDisc = Mes[IOff++];
 
-    /* Message Type */
-    m->MesType = Mes[IOff++];
+		/* CRV */
+		m->CRVFlag = Mes[IOff + 1] & 0x80;
+		m->CRV = Q931Uie_CRV(pTrunk, Mes, m->buf, &IOff, &ISize);
 
-    /* Call table proc to unpack codec message */
-    /*debug */
-    /* printf("\n\nQ931Rx23-  Dialect: %d, MsgType: %d\n",pTrunk->Dialect,m->MesType); */
-    RetCode = Q931Umes[pTrunk->Dialect][m->MesType](pTrunk, Mes, (Q931mes_Generic *)pTrunk->L3Buf, Q931L4HeaderSpace + IOff , Size - Q931L4HeaderSpace - IOff + 1);
+		/* Message Type */
+		m->MesType = Mes[IOff++];
 
-    if(RetCode >= Q931E_NO_ERROR)
-    {
-        RetCode = Q931Proc[pTrunk->Dialect][m->MesType](pTrunk, pTrunk->L3Buf, 2);
-    }
+		RetCode = Q931Umes[pTrunk->Dialect][m->MesType](pTrunk, Mes, (Q931mes_Generic *)pTrunk->L3Buf, IOff, Size - IOff + 1);
 
-    return RetCode;
+		if(RetCode >= Q931E_NO_ERROR)
+		{
+			RetCode = Q931Proc[pTrunk->Dialect][m->MesType](pTrunk, pTrunk->L3Buf, 2);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return RetCode;
 }
 
 /*****************************************************************************
@@ -378,10 +386,12 @@
 *****************************************************************************/
 L3INT Q931Tx34(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
 {
-    if (pTrunk->Q931Tx34CBProc) {
-        return pTrunk->Q931Tx34CBProc(pTrunk->PrivateData34, Mes, Size);
-    }
-    return Q931E_MISSING_CB;    
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Sending message to Layer4 (size: %d)\n", Size);
+
+	if (pTrunk->Q931Tx34CBProc) {
+		return pTrunk->Q931Tx34CBProc(pTrunk->PrivateData34, Mes, Size);
+	}
+	return Q931E_MISSING_CB;    
 }
 
 /*****************************************************************************
@@ -400,19 +410,18 @@
 *****************************************************************************/
 L3INT Q931Rx43(Q931_TrunkInfo_t *pTrunk,L3UCHAR * buf, L3INT Size)
 {
-    Q931mes_Header *ptr = (Q931mes_Header*)&buf[Q931L4HeaderSpace];
-    L3INT RetCode = Q931E_NO_ERROR;
+	Q931mes_Header *ptr = (Q931mes_Header*)&buf[Q931L4HeaderSpace];
 
-    RetCode=Q931Proc[pTrunk->Dialect][ptr->MesType](pTrunk,buf,4);
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Receiving message from Layer4 (size: %d)\n", Size);
 
-    return RetCode;
+	return Q931Proc[pTrunk->Dialect][ptr->MesType](pTrunk,buf,4);;
 }
 
 /*****************************************************************************
 
-  Function:     Q931Tx32
+  Function:     Q931Tx32Data
 
-  Description:  Called from the stack to send a message to L2. The input is 
+  Description:  Called from the stack to send a DL-DATA message to L2. The input is 
                 always a non-packed message so it will first make a proper
                 call to create a packed message before it transmits that
                 message to layer 2.
@@ -425,28 +434,56 @@
                 see q931errors.h for details.
 
 *****************************************************************************/
-L3INT Q931Tx32(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
+L3INT Q931Tx32Data(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
 {
-    L3INT     OSize;
-    Q931mes_Generic *ptr = (Q931mes_Generic*)Mes;
-    L3INT RetCode = Q931E_NO_ERROR;
-    L3INT iDialect = pTrunk->Dialect;
+	Q931mes_Generic *ptr = (Q931mes_Generic*)Mes;
+	L3INT RetCode = Q931E_NO_ERROR;
+	L3INT iDialect = pTrunk->Dialect;
+	L3INT OSize;
 
-    /* Call pack function through table. */
-    RetCode = Q931Pmes[iDialect][ptr->MesType](pTrunk, (Q931mes_Generic *)Mes, Size, &pTrunk->L2Buf[Q931L2HeaderSpace], &OSize);
-    if(RetCode >= Q931E_NO_ERROR)
-    {
-        if (pTrunk->Q931Tx32CBProc) {
-            RetCode = pTrunk->Q931Tx32CBProc(pTrunk->PrivateData32, pTrunk->L2Buf, OSize + Q931L2HeaderSpace);
-        } else {
-            RetCode = Q931E_MISSING_CB;
-        }
-    }
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Sending DL-DATA request message to Q.921 (size: %d)\n", Size);
 
-    return RetCode;
+	/* Call pack function through table. */
+	RetCode = Q931Pmes[iDialect][ptr->MesType](pTrunk, (Q931mes_Generic *)Mes, Size, &pTrunk->L2Buf[Q931L2HeaderSpace], &OSize);
+	if(RetCode >= Q931E_NO_ERROR)
+	{
+		if (pTrunk->Q931Tx32CBProc) {
+			RetCode = pTrunk->Q931Tx32CBProc(pTrunk->PrivateData32, Q921_DL_DATA, pTrunk->L2Buf, OSize + Q931L2HeaderSpace);
+		} else {
+			RetCode = Q931E_MISSING_CB;
+		}
+	}
+
+	return RetCode;
 }
 
+/**
+ * Q931Tx32UnitData
+ * \brief	Used to send a DL-UNIT DATA Request to Layer2
+ */
+L3INT Q931Tx32UnitData(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
+{
+	Q931mes_Generic *ptr = (Q931mes_Generic*)Mes;
+	L3INT RetCode = Q931E_NO_ERROR;
+	L3INT iDialect = pTrunk->Dialect;
+	L3INT OSize;
 
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Sending DL-UNIT DATA request message to Q.921 (size: %d)\n", Size);
+
+	/* Call pack function through table. */
+	RetCode = Q931Pmes[iDialect][ptr->MesType](pTrunk, (Q931mes_Generic *)Mes, Size, &pTrunk->L2Buf[Q931L2HeaderSpace-1], &OSize);
+	if(RetCode >= Q931E_NO_ERROR)
+	{
+		if (pTrunk->Q931Tx32CBProc) {
+			RetCode = pTrunk->Q931Tx32CBProc(pTrunk->PrivateData32, Q921_DL_UNIT_DATA, pTrunk->L2Buf, OSize + Q931L2HeaderSpace - 1);
+		} else {
+			RetCode = Q931E_MISSING_CB;
+		}
+	}
+
+	return RetCode;
+}
+
 /*****************************************************************************
 
   Function:     Q931SetError
@@ -461,16 +498,16 @@
 *****************************************************************************/
 void Q931SetError(Q931_TrunkInfo_t *pTrunk,L3INT ErrID, L3INT ErrPar1, L3INT ErrPar2)
 {
-    if (pTrunk->Q931ErrorCBProc) {
-        pTrunk->Q931ErrorCBProc(pTrunk->PrivateData34, ErrID, ErrPar1, ErrPar2);
-    } else {
-        Q931ErrorProc(pTrunk->PrivateData34, ErrID, ErrPar1, ErrPar2);
-    }
+	if (pTrunk->Q931ErrorCBProc) {
+		pTrunk->Q931ErrorCBProc(pTrunk->PrivateData34, ErrID, ErrPar1, ErrPar2);
+	} else {
+		Q931ErrorProc(pTrunk->PrivateData34, ErrID, ErrPar1, ErrPar2);
+	}
 }
 
 void Q931SetDefaultErrorCB(Q931ErrorCB_t Q931ErrorPar)
 {
-    Q931ErrorProc = Q931ErrorPar;
+	Q931ErrorProc = Q931ErrorPar;
 }
 
 /*****************************************************************************
@@ -488,15 +525,15 @@
                 see q931errors.h for details.
 
 *****************************************************************************/
-L3INT    Q931CreateCRV(Q931_TrunkInfo_t *pTrunk, L3INT * callIndex)
+L3INT Q931CreateCRV(Q931_TrunkInfo_t *pTrunk, L3INT * callIndex)
 {
-    L3INT CRV = Q931GetUniqueCRV(pTrunk);
+	L3INT CRV = Q931GetUniqueCRV(pTrunk);
 
-    return Q931AllocateCRV(pTrunk, CRV, callIndex);
+	return Q931AllocateCRV(pTrunk, CRV, callIndex);
 }
 
 
-L3INT	Q931ReleaseCRV(Q931_TrunkInfo_t *pTrunk, L3INT CRV)
+L3INT Q931ReleaseCRV(Q931_TrunkInfo_t *pTrunk, L3INT CRV)
 {
 	int callIndex;
 	
@@ -757,3 +794,51 @@
 }
 
 
+/*
+ * Logging
+ */
+#include <stdarg.h>
+
+L3INT Q931Log(Q931_TrunkInfo_t *trunk, Q931LogLevel_t level, const char *fmt, ...)
+{
+	char  buf[Q931_LOGBUFSIZE];
+	L3INT len;
+	va_list ap;
+
+	if(!trunk->Q931LogCBProc)
+		return 0;
+
+	if(trunk->loglevel < level)
+		return 0;
+
+	va_start(ap, fmt);
+
+	len = vsnprintf(buf, sizeof(buf)-1, fmt, ap);
+	if(len <= 0) {
+		/* TODO: error handling */
+		return -1;
+	}
+
+	va_end(ap);
+
+	return trunk->Q931LogCBProc(trunk->PrivateDataLog, level, buf, strnlen(buf, sizeof(buf)-1));
+}
+
+/**
+ * Q921SetLogCB
+ * \brief	Set Logging callback function and private data
+ */
+void Q931SetLogCB(Q931_TrunkInfo_t *trunk, Q931LogCB_t func, void *priv)
+{
+	trunk->Q931LogCBProc = func;
+	trunk->PrivateDataLog = priv;
+}
+
+/**
+ * Q921SetLogLevel
+ * \brief	Set Loglevel
+ */
+void Q931SetLogLevel(Q931_TrunkInfo_t *trunk, Q931LogLevel_t level)
+{
+	trunk->loglevel = level;
+}
